类似于1014,用splay维护这个序列,维护每个节点为根的子树的hash值,对于一个询问二分答案判断就行了。

  反思:询问的时候因为是原序列的x,y,所以开始的时候直接splay(x-1)了,后来发现这是不对的,因为可能在x前插入一些东西,所以需要麻烦些,先splay(x),然后提出来右端点为size[son[rot][0]]+1+len,然后再splay(find(size[son[rot][0]]+1))。

/**************************************************************
    Problem: 2258
    User: BLADEVIL
    Language: C++
    Result: Accepted
    Time:7904 ms
    Memory:3640 kb
****************************************************************/
 
//By BLADEVIL
#include <cstdio>
#include <cstring>
#include <algorithm>
#define maxn 100010
 
using namespace std;
 
char s[maxn];
int fac[maxn],key[maxn],num,rot,son[maxn][],father[maxn],size[maxn],hash[maxn];
 
void update(int x) {
    if (!x) return ;
    hash[x]=hash[son[x][]]+(key[x]+hash[son[x][]]*)*fac[size[son[x][]]];
    size[x]=size[son[x][]]+size[son[x][]]+;
}
 
int build(int l,int r) {
    int mid=l+r>>,left=,right=;
    if (mid<r) right=build(mid+,r);
    if (mid>l) left=build(l,mid-);
    father[left]=father[right]=mid;
    son[mid][]=left; son[mid][]=right;
    update(mid);
    return mid;
}
 
void rotate(int x,int &rot) {
    int y=father[x],z=father[y];
    int p=(son[y][]==x),q=p^;
    if (y==rot) rot=x; else if (son[z][]==y) son[z][]=x; else son[z][]=x;
    father[x]=z; father[y]=x; father[son[x][q]]=y;
    son[y][p]=son[x][q]; son[x][q]=y;
    update(y);
}
 
void splay(int x,int &rot) {
    while (x!=rot) {
        int y=father[x],z=father[y];
        if (y!=rot)
            if ((son[y][]==x)^(son[z][]==y)) rotate(x,rot); else rotate(y,rot);
        rotate(x,rot);
    }
    update(x);
}
 
int find(int x) {
    int t=rot;
    while () {
        if (size[son[t][]]+==x) return t; else
        if (size[son[t][]]+>x) t=son[t][]; else
        if (size[son[t][]]+<x) x-=size[son[t][]]+,t=son[t][];
    }
}
 
bool judge(int x,int y,int len) {
    if (len==) return key[x+]==key[y+];
    int p=x+; splay(p,rot);
    int q=find(size[son[rot][]]++len);
    splay(find(size[son[rot][]]),rot); splay(q,son[rot][]);
    int a1=hash[son[q][]];
    p=y+; splay(p,rot);
    q=find(size[son[rot][]]++len);
    splay(find(size[son[rot][]]),rot); splay(q,son[rot][]);
    int a2=hash[son[q][]];
    return a1==a2;
}
 
int main() {
    scanf("%s",s); num=strlen(s);
    fac[]=; for (int i=;i<maxn;i++) fac[i]=fac[i-]*;
    for (int i=;i<=num+;i++) key[i]=s[i-]-'a'+; num+=;
    rot=build(,num);
    int task; scanf("%d",&task);
    while (task--) {
        int x,y;
        scanf("%s",s);
        if (s[]=='Q') {
            scanf("%d%d",&x,&y);
            if (x>y) swap(x,y);
            splay(y+,rot);
            int l=,r=size[son[rot][]],mid,ans=;
            while (l<=r) {
                mid=l+r>>;
                if (judge(x,y,mid)) ans=mid, l=mid+; else r=mid-;
            }
            printf("%d\n",ans);
        } else
        if (s[]=='I') {
            scanf("%s%d",s,&x);
            x=(x>num-)?num:x;
            key[++num]=s[]-'a'+;
            int p=find(x); splay(p,rot);
            int q=find(x+); splay(q,son[rot][]);
            father[num]=q; son[q][]=num;
            splay(num,rot);
        }
    }
    return ;  
}

bzoj 2258 splay的更多相关文章

  1. bzoj 1269 bzoj 1507 Splay处理文本信息

    bzoj 1269 题目:http://www.lydsy.com/JudgeOnline/problem.php?id=1269 大致思路: 用splay维护整个文本信息,splay树的中序遍历即为 ...

  2. bzoj 3506 && bzoj 1552 splay

    查最小值,删除,翻转... 显然splay啊... #include<iostream> #include<cstdio> #include<algorithm> ...

  3. bzoj 1014 splay维护hash值

    被后缀三人组虐了一下午,写道水题愉悦身心. 题很裸,求lcq时二分下答案就行了,写的不优美会被卡时. (写题时精神恍惚,不知不觉写了快两百行...竟然调都没调就A了...我还是继续看后缀自动机吧... ...

  4. bzoj 1503 splay

    因为是整体加减,所以直接记录在外面. #include<iostream> #include<cstdio> #include<cstring> #include& ...

  5. bzoj 3224 splay模板题4

    再刷水题我就废了... #include<iostream> #include<cstdio> #include<algorithm> #include<cs ...

  6. bzoj 3223 splay模板题3

    水题...貌似理解splay怎么维护数列了... 每个点维护一个size,它的位置就是它的size,区间翻转的话可以打标记,find的时候push_down,交换左右子树. #include<i ...

  7. bzoj 1208 splay模板题2

    自己yy了找前驱和后继,学了学怎么删除...(反正就是练模板) #include<iostream> #include<cstdio> #include<cstring& ...

  8. bzoj 1588 splay模板题

    用晚自习学了一下splay模板,没想象中那么难,主要是左旋和右旋可以简化到一个函数里边,减少代码长度... #include<iostream> #include<cstdio> ...

  9. BZOJ 2733 & splay的合并

    题意: 带权联通块,添边与查询联通块中第k大. SOL: splay合并+并查集. 我以为splay可以用奇技淫巧来简单合并...调了一下午终于幡然醒悟...于是就只好一个一个慢慢插...什么启发式合 ...

随机推荐

  1. PAT 甲级 1038 Recover the Smallest Number

    https://pintia.cn/problem-sets/994805342720868352/problems/994805449625288704 Given a collection of ...

  2. 网络编程--System.Net

    using System; using System.Collections.Generic; using System.ComponentModel; using System.Data; usin ...

  3. Visual Studio 数据库架构比较

      一.前言 开发的时候在测试服务器上和线网服务器上面都有我们的数据库,当我们在线网上面修改或者新增一些字段后,线网的数据库也需要更新,这个时候根据表的修改记录,然后在线网上面一个一个增加修改很浪费效 ...

  4. str.substring(beginIndex,endIndex)-008

    // 将字符串str前n位放在后面,返回新的字符串 public String headToTail(String str,int n){ if(n==0){ System.out.println(s ...

  5. 青花瓷运用->下载历史版本App

    1.软件准备 [必备]Charles4.0.1 下载密码: jfnk [不需要,配合Charles食用效果更佳]Paw2.3.1 下载密码: t3my 2.正式开始 2.1 打开Charles青花瓷 ...

  6. BZOJ2555:SubString——题解

    https://www.lydsy.com/JudgeOnline/problem.php?id=2555 (1):在当前字符串的后面插入一个字符串 (2):询问字符串s在当前字符串中出现了几次?(作 ...

  7. BZOJ2724:[Violet 6]蒲公英——题解

    http://www.lydsy.com/JudgeOnline/problem.php?id=2724 输入格式 第一行两个整数n,m,表示有n株蒲公英,m次询问. 接下来一行 n 个空格分隔的整数 ...

  8. MySQL中数据表的基本操纵

    本文基于对国家863中部软件孵化器编著的<MySQL从入门到精通>一书的操作实践.  一.创建数据表 数据表属于数据库,在创建数据表之前,应该使用语句 USE 数据库名  指定操作是在那个 ...

  9. [Leetcode] valid parentheses 有效括号对

    Given a string containing just the characters'(',')','{','}','['and']', determine if the input strin ...

  10. [Leetcode] valid sudoku 有效数独

    Determine if a Sudoku is valid, according to: Sudoku Puzzles - The Rules. The Sudoku board could be ...